const assert = require('assert')
const Pitch = require('../src/pitch')

const round = (n, precision=1000)=> (n * precision | 0)/precision
describe('pitch', ()=>{
	it('numbered', ()=>{
		const pitch = new Pitch({note: 0, interval: 0})
		assert.equal(+pitch, 16.3516)
		assert.equal(pitch.hz, 16.3516)
		assert.equal(pitch.name, 'C0')
		assert.equal(pitch.note, 0)
		assert.equal(pitch.interval, 0)
		assert.equal(pitch.number, 0)
	})
	it('note number', ()=>{
		const pitch = new Pitch({note: 13})
		assert.equal(round(+pitch), 34.647)
		assert.equal(round(pitch.hz), 34.647)
		assert.equal(pitch.name, 'C#1')
		assert.equal(pitch.note, 1)
		assert.equal(pitch.interval, 1)
		assert.equal(pitch.number, 13)
	})
	it('interval number', ()=>{
		const pitch = new Pitch({interval: 1})
		assert.equal(round(+pitch), 32.703)
		assert.equal(round(pitch.hz), 32.703)
		assert.equal(pitch.name, 'C1')
		assert.equal(pitch.note, 0)
		assert.equal(pitch.interval, 1)
		assert.equal(pitch.number, 12)
	})
	it('interval number fractioned', ()=>{
		const pitch = new Pitch({interval: 1 + 1/12})
		assert.equal(round(+pitch), 34.647)
		assert.equal(round(pitch.hz), 34.647)
		assert.equal(pitch.name, 'C#1')
		assert.equal(pitch.note, 1)
		assert.equal(pitch.interval, 1)
		assert.equal(pitch.number, 13)
	})
	it('named', ()=>{
		const pitch = new Pitch({name: 'A0'})
		assert.equal(round(+pitch), 27.5)
		assert.equal(round(pitch.hz), 27.5)
		assert.equal(pitch.name, 'A0')
		assert.equal(pitch.note, 9)
		assert.equal(pitch.interval, 0)
		assert.equal(pitch.number, 9)
	})
	it('hz', ()=>{
		const pitch = new Pitch({hz: 27.5})
		assert.equal(+pitch, 27.5)
		assert.equal(pitch.hz, 27.5)
		assert.equal(pitch.name, 'C0')
		assert.equal(pitch.note, 0)
		assert.equal(pitch.interval, 0)
		assert.equal(pitch.number, 0)

		const pitch2 = new Pitch({hz: 0})
		assert.equal(+pitch2, 0)
		assert.equal(pitch2.hz, 0)
		assert.equal(pitch2.name, 'C0')
		assert.equal(pitch2.note, 0)
		assert.equal(pitch2.interval, 0)
		assert.equal(pitch2.number, 0)
	})
	it('empty', ()=>{
		const pitch = new Pitch()
		assert.equal(+pitch, 16.3516)
		assert.equal(pitch.hz, 16.3516)
		assert.equal(pitch.name, 'C0')
		assert.equal(pitch.note, 0)
		assert.equal(pitch.interval, 0)
		assert.equal(pitch.number, 0)
	})
	it('fromValue', ()=>{
		const pitch = Pitch.fromValue(6)
		assert.equal(+pitch, 6)
		assert.equal(pitch.hz, 6)
		assert.equal(pitch.name, 'C0')
		assert.equal(pitch.note, 0)
		assert.equal(pitch.interval, 0)
		assert.equal(pitch.number, 0)
	})
	describe('from', ()=>{
		it('pitch', ()=>{
			const pitch = new Pitch({note: 13})
			assert.equal(round(+pitch), 34.647)
			assert.equal(round(pitch.hz), 34.647)
			assert.equal(pitch.name, 'C#1')
			assert.equal(pitch.note, 1)
			assert.equal(pitch.interval, 1)
			assert.equal(pitch.number, 13)

			const pitch2 = Pitch.from(pitch)
			assert.equal(round(+pitch2), 34.647)
			assert.equal(round(pitch2.hz), 34.647)
			assert.equal(pitch2.name, 'C#1')
			assert.equal(pitch2.note, 1)
			assert.equal(pitch2.interval, 1)
			assert.equal(pitch2.number, 13)
		})
		it('number', ()=>{
			const pitch = Pitch.from(13)
			assert.equal(round(+pitch), 34.647)
			assert.equal(round(pitch.hz), 34.647)
			assert.equal(pitch.name, 'C#1')
			assert.equal(pitch.note, 1)
			assert.equal(pitch.interval, 1)
			assert.equal(pitch.number, 13)
		})
		it('object', ()=>{
			const pitch = Pitch.from({note: 13})
			assert.equal(round(+pitch), 34.647)
			assert.equal(round(pitch.hz), 34.647)
			assert.equal(pitch.name, 'C#1')
			assert.equal(pitch.note, 1)
			assert.equal(pitch.interval, 1)
			assert.equal(pitch.number, 13)
		})
	})
})
